//definizioni velocità
int partenza = 3000; //ritardo iniziale per la partenza (in ms)

int avanti = 110;        //velocità avanti ricerca tra 60 e 80
int ricerca = 100;        //velocità gira in ricerca tra 60 e 80
int indietro = 180;        //velocità indietro tra 60 e 80
int avanti_att = 190;    //velocità di attacco in avanti
int rotazione =  90;        //velocità pan usata in attacco

int tempo_rotazione = 20; 
//delay per il pan in attacco (in ms)

int allarme1=220;    //soglia per passare allo stato avvicinamento avversario tra 40 e 60
int allarme_attacco=380;   //soglia per passare allo stato di attacco tra 160 e 180



//piedinatura
int STBY = 4;                //pin per stby motori OUT              (STBY)

int vel_mot_s = 5;          //pin velocità motore sinistro OUT       (PWMA)
int vel_mot_d = 10;          //pin velocità motore destro   OUT       (PWMB)
int dir_A_mot_s = 7;         //pin A direzione motore sinistro OUT   (AIN2)
int dir_B_mot_s = 6;         //pin B direzione motore sinistro OUT   (AIN1)
int dir_A_mot_d = 8;         //pin A direzione motore destro OUT     (BIN1)
int dir_B_mot_d = 9;         //pin B direzione motore destro OUT     (BIN2)
int inputTeleL = 1;  //sensori sharp IR
int inputTeleR = 0;  //sensori sharp IR
int inputSirL = 13;  //ir linea left
int inputSirC = 3;  //ir linea center
int inputSirR = 2;  //ir linea right
int inputSirB = 2;  //ir linea back

int buzz = 12;
//int intens = A3;
int light = 11;
//int puls = A4;



int ist=20;


//definizioni
int sir_stimL;
int sir_stimC;
int sir_stimR;
int sir_stimB;
boolean sir_warn; 
int sir_offset;  //sbilanciamento 0-1023   [R most stim  >0] [L most stim  <0]

int tele_stimL;
int tele_stimR;
int tele_warn; 
int tele_offset;  //sbilanciamento 0-1023  [R most stim  >0] [L most stim  <0]

char side;


void setup() {
  //preset
   Serial.begin(9600);            // initialize serial communication with computer
   
   pinMode(vel_mot_s,OUTPUT);
   pinMode(vel_mot_d,OUTPUT);
   pinMode(dir_A_mot_s,OUTPUT);
   pinMode(dir_B_mot_s,OUTPUT);
   pinMode(dir_A_mot_d,OUTPUT);
   pinMode(dir_B_mot_d,OUTPUT);
   pinMode(STBY,OUTPUT);
    pinMode(light,OUTPUT);
   pinMode(tele_stimL,INPUT);
   pinMode(tele_stimR,INPUT);
   pinMode(inputSirL,INPUT);
   pinMode(inputSirR,INPUT);
   pinMode(inputSirC,INPUT); 
   pinMode(inputSirB,INPUT); 
   
   //motor off
   digitalWrite(dir_A_mot_s,LOW);
   digitalWrite(dir_B_mot_s,HIGH);
   digitalWrite(dir_A_mot_d,LOW);
   digitalWrite(dir_B_mot_d,HIGH);
   analogWrite(vel_mot_s,0);
   analogWrite(vel_mot_d,0);
   digitalWrite(STBY,LOW);
   
   delay(partenza);
} 

void loop() {
  

//pan a destra
motorSet("RP",rotazione);
delay(300);
motorSet("XX",0);
  
surv://SURVIVE BORDERS /////////////////////////////////////////////////////////////////////////////////////

  Serial.println("linea");
     
   readSir();
   if ( sir_stimR==1 )  {side='L';motorSet("BB",indietro);yield(600);motorSet("RP",rotazione);yield(400); } 
   else if ( sir_stimL==1 ){side='R';motorSet("BB",indietro);yield(600);motorSet("LP",rotazione);yield(400); } 
   else if ( sir_stimC==1 ){side='R';motorSet("RB",indietro);yield(700);motorSet("RP",rotazione);yield(400); }  
     
else {motorSet("FF",ricerca); } 
   
   do{
     readSir();
   }while(sir_warn); 
   
   hunt://HUNT OPPONENT /////////////////////////////////////////////////////////////////////////////////////
   Serial.println("caccia");
   
   if (side=='R'){ motorSet("LF",ricerca); }                     //caccia nella direzione presettata 
   else {motorSet("RF",ricerca);
}                               //caccia nella direzione presettata 
   
   do{
     readSir();  if (sir_warn)  {goto surv;}
     readTele();
     
   }while(tele_warn==0); 
   
      
   trgt://TARGET OPPONENT /////////////////////////////////////////////////////////////////////////////////////
   Serial.println("obiettivo");
     
     readTele();
     
     while(tele_warn != 0) {      
       readSir();if (sir_warn) {goto surv;}                  //se al bordo vai a suvive
       
       if (tele_warn == 2) {
         if(abs(tele_offset) < 70){goto attk;}
         else if(tele_offset > 170) {
           motorSet("LP",rotazione);side='R';
           delay(tempo_rotazione);
           motorSet("XX",0);           
         }
         
         else if(tele_offset < 170) {
           motorSet("RP",rotazione);side='L';
           delay(tempo_rotazione);
           motorSet("XX",0);
         }
       }
       
       else if (tele_warn == 1) {
         if(abs(tele_offset) < 50){
           motorSet(" BB",avanti);
           motorSet("LP",rotazione);yield(400);

         }
         if(tele_offset > 0) {
           motorSet("LF",ricerca);side='R';
         }
         
         else if(tele_offset < 0) {
           motorSet("RF",ricerca);side='L';
     
         }
       }              
       
       readTele();
     }
     goto hunt;
   
   attk://ATTACK ///////////////////////////////////////////////////////////////////////////////////// 
   
   Serial.println("attacco");
   do{
     motorSet("FF",avanti_att);
     readSir();
     readTele();
     tone (buzz,3000,2000);
     digitalWrite (light,HIGH);
     digitalWrite (light,LOW);
     digitalWrite (light,HIGH);
   }while((!sir_warn) && (tele_warn==2));
   
   if(sir_warn) {digitalWrite (light,LOW); goto surv;}
   else if(tele_warn==1) {digitalWrite (light,LOW);  goto trgt; } 
   else if(tele_warn==0) {digitalWrite (light,LOW);  goto hunt;}
     
} 












